module Robot_clock where

newtype Odlist a = ODList [a] deriving (Eq, Ord, Show)
newtype Mapping a b = Mapping [(a, b)] deriving Show
data Trie a b = Trie (Maybe b) [(a, Trie a b)] deriving Show

data AlgState_ext a b c = AlgState_ext a b c deriving Show
data BEState_ext a b c d = BEState_ext b (Odlist (a, c)) d deriving (Eq, Ord, Show)

data Digit = A | B | C | D | E | F deriving (Eq, Ord)

instance Show Digit where
  show A = "0"
  show B = "1"
  show C = "2"
  show D = "3"
  show E = "4"
  show F = "5"

data Agent = Robot deriving (Eq, Ord, Show)
data RobotAct = Nop | Halt deriving (Eq, Ord, Show)

mc_init = [((A,(A,False)),(ODList [(A,(A,False)),(A,(B,False))],ODList [(A,(A,False))])),((A,(B,False)),(ODList [(A,(A,False)),(A,(B,False))],ODList [(A,(B,False))]))]
mc_dfs_output = AlgState_ext (Trie Nothing [((A,(A,False)),Trie Nothing [((A,(B,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie (Just [Nop]) []),((A,(B,False)),Trie (Just [Nop]) [])])) [((B,(A,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((B,(C,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just [Nop]) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie (Just [Nop]) [])]),((B,(C,False)),Trie (Just [Nop]) [])])) [((C,(B,False)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(D,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just [Nop]) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((C,(B,False)),Trie (Just [Nop]) [])])]),((B,(C,False)),Trie Nothing [((C,(C,False)),Trie (Just [Nop]) [])]),((C,(D,False)),Trie (Just [Halt]) [])])) [])]),((C,(B,True)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(C,True)),Trie Nothing [((C,(D,False)),Trie Nothing [((C,(D,True)),Trie Nothing [((D,(C,False)),Trie Nothing [((D,(D,False)),Trie Nothing [((D,(E,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just [Nop]) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((C,(B,False)),Trie Nothing [((C,(B,True)),Trie (Just [Nop]) [])])])]),((B,(C,False)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(C,True)),Trie Nothing [((D,(C,False)),Trie (Just [Nop]) [])])])]),((C,(D,False)),Trie Nothing [((C,(D,True)),Trie Nothing [((D,(D,False)),Trie (Just [Halt]) [])])]),((D,(E,False)),Trie (Just [Halt]) [])])) [])]),((D,(C,True)),Trie Nothing [((D,(D,False)),Trie Nothing [((D,(D,True)),Trie Nothing [((D,(E,False)),Trie Nothing [((D,(E,True)),Trie Nothing [((E,(D,False)),Trie Nothing [((E,(E,False)),Trie Nothing [((E,(F,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just [Nop]) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((C,(B,False)),Trie Nothing [((C,(B,True)),Trie (Just [Nop]) [])])])]),((B,(C,False)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(C,True)),Trie Nothing [((D,(C,False)),Trie Nothing [((D,(C,True)),Trie (Just [Nop]) [])])])])]),((C,(D,False)),Trie Nothing [((C,(D,True)),Trie Nothing [((D,(D,False)),Trie Nothing [((D,(D,True)),Trie Nothing [((E,(D,False)),Trie (Just [Halt]) [])])])])]),((D,(E,False)),Trie Nothing [((D,(E,True)),Trie Nothing [((E,(E,False)),Trie (Just [Halt]) [])])]),((E,(F,False)),Trie (Just [Halt]) [])])) [])]),((E,(D,True)),Trie Nothing [((E,(E,False)),Trie Nothing [((E,(E,True)),Trie Nothing [((E,(F,False)),Trie Nothing [((E,(F,True)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just [Nop]) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((C,(B,False)),Trie Nothing [((C,(B,True)),Trie (Just [Nop]) [])])])]),((B,(C,False)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(C,True)),Trie Nothing [((D,(C,False)),Trie Nothing [((D,(C,True)),Trie (Just [Nop]) [])])])])]),((C,(D,False)),Trie Nothing [((C,(D,True)),Trie Nothing [((D,(D,False)),Trie Nothing [((D,(D,True)),Trie Nothing [((E,(D,False)),Trie Nothing [((E,(D,True)),Trie (Just [Halt]) [])])])])])]),((D,(E,False)),Trie Nothing [((D,(E,True)),Trie Nothing [((E,(E,False)),Trie Nothing [((E,(E,True)),Trie (Just [Halt]) [])])])]),((E,(F,False)),Trie Nothing [((E,(F,True)),Trie (Just [Halt]) [])])])) [])])])])])])])])])])])])])])])])])])])])])])])]) (Trie Nothing [((A,(A,False)),Trie Nothing [((A,(B,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie (Just (Mapping [(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False))],ODList [(B,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False))],ODList [(A,(B,False)),(B,(B,False))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False))],ODList [(A,(A,False)),(B,(A,False))]))])) []),((A,(B,False)),Trie (Just (Mapping [(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False))],ODList [(B,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False))],ODList [(A,(B,False)),(B,(B,False))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])) [((B,(A,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((B,(C,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just (Mapping [(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(C,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(B,(C,False)),(C,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie (Just (Mapping [(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(C,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(B,(C,False)),(C,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])]),((B,(C,False)),Trie (Just (Mapping [(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(C,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(B,(C,False)),(C,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(C,False)),(C,(D,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])) [((C,(B,False)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(D,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just (Mapping [(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((C,(B,False)),Trie (Just (Mapping [(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(D,(E,False))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])]),((B,(C,False)),Trie Nothing [((C,(C,False)),Trie (Just (Mapping [(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(D,(E,False))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])]),((C,(D,False)),Trie (Just (Mapping [(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(D,False)),(D,(E,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))]))])) [])])) [])]),((C,(B,True)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(C,True)),Trie Nothing [((C,(D,False)),Trie Nothing [((C,(D,True)),Trie Nothing [((D,(C,False)),Trie Nothing [((D,(D,False)),Trie Nothing [((D,(E,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just (Mapping [(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((C,(B,False)),Trie Nothing [((C,(B,True)),Trie (Just (Mapping [(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])])]),((B,(C,False)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(C,True)),Trie Nothing [((D,(C,False)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(E,(F,False))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])])]),((C,(D,False)),Trie Nothing [((C,(D,True)),Trie Nothing [((D,(D,False)),Trie (Just (Mapping [(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))]))])) [])])]),((D,(E,False)),Trie (Just (Mapping [(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(E,False)),(E,(F,False))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))]))])) [])])) [])]),((D,(C,True)),Trie Nothing [((D,(D,False)),Trie Nothing [((D,(D,True)),Trie Nothing [((D,(E,False)),Trie Nothing [((D,(E,True)),Trie Nothing [((E,(D,False)),Trie Nothing [((E,(E,False)),Trie Nothing [((E,(F,False)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just (Mapping [(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(A,False)),(B,(A,False))]))])) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((C,(B,False)),Trie Nothing [((C,(B,True)),Trie (Just (Mapping [(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])])]),((B,(C,False)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(C,True)),Trie Nothing [((D,(C,False)),Trie Nothing [((D,(C,True)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(E,(F,False)),(E,(F,True))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])])])]),((C,(D,False)),Trie Nothing [((C,(D,True)),Trie Nothing [((D,(D,False)),Trie Nothing [((D,(D,True)),Trie Nothing [((E,(D,False)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(E,(F,False)),(E,(F,True))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))]))])) [])])])])]),((D,(E,False)),Trie Nothing [((D,(E,True)),Trie Nothing [((E,(E,False)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(E,(F,False)),(E,(F,True))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))]))])) [])])]),((E,(F,False)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(E,(F,False)),(E,(F,True))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))]))])) [])])) [])]),((E,(D,True)),Trie Nothing [((E,(E,False)),Trie Nothing [((E,(E,True)),Trie Nothing [((E,(F,False)),Trie Nothing [((E,(F,True)),Trie (Just (Trie Nothing [((A,(A,False)),Trie Nothing [((B,(A,False)),Trie (Just (Mapping [(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(A,False)),(B,(A,False))]))])) [])]),((A,(B,False)),Trie Nothing [((B,(B,False)),Trie Nothing [((C,(B,False)),Trie Nothing [((C,(B,True)),Trie (Just (Mapping [(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])])]),((B,(C,False)),Trie Nothing [((C,(C,False)),Trie Nothing [((C,(C,True)),Trie Nothing [((D,(C,False)),Trie Nothing [((D,(C,True)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(E,(F,False)),(E,(F,True))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))])),(A,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(A,False)),(B,(A,False))]))])) [])])])])]),((C,(D,False)),Trie Nothing [((C,(D,True)),Trie Nothing [((D,(D,False)),Trie Nothing [((D,(D,True)),Trie Nothing [((E,(D,False)),Trie Nothing [((E,(D,True)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(E,(F,False)),(E,(F,True))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))])),(B,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(A,(B,False)),(B,(B,False)),(C,(B,False)),(C,(B,True))]))])) [])])])])])]),((D,(E,False)),Trie Nothing [((D,(E,True)),Trie Nothing [((E,(E,False)),Trie Nothing [((E,(E,True)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(E,(F,False)),(E,(F,True))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))])),(C,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(B,(C,False)),(C,(C,False)),(C,(C,True)),(D,(C,False)),(D,(C,True))]))])) [])])])]),((E,(F,False)),Trie Nothing [((E,(F,True)),Trie (Just (Mapping [(F,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(E,(F,False)),(E,(F,True))])),(E,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(D,(E,False)),(D,(E,True)),(E,(E,False)),(E,(E,True))])),(D,(ODList [(A,(A,False)),(A,(B,False)),(B,(A,False)),(B,(B,False)),(B,(C,False)),(C,(B,False)),(C,(B,True)),(C,(C,False)),(C,(C,True)),(C,(D,False)),(C,(D,True)),(D,(C,False)),(D,(C,True)),(D,(D,False)),(D,(D,True)),(D,(E,False)),(D,(E,True)),(E,(D,False)),(E,(D,True)),(E,(E,False)),(E,(E,True)),(E,(F,False)),(E,(F,True))],ODList [(C,(D,False)),(C,(D,True)),(D,(D,False)),(D,(D,True)),(E,(D,False)),(E,(D,True))]))])) [])])])) [])])])])])])])])])])])])])])])])])])])])])])])]) ()
